Lattice Grid Buy a licence

demo D165

Pie, donut, sunburst, treemap

Composition, flat and hierarchical

type: 'pie' · 'donut' · 'sunburst' · 'treemap'

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
    { field: 'charge', title: 'Monthly charge', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
  ];

  const rows = [/* circuit records */];

  function App() {
    const gridRef = React.useRef(null);

    // The part-to-whole types each read the live grid through the ref, so a
    // filter redraws them together.
    React.useEffect(() => {
      const grid = gridRef.current.grid;
      createChart({ grid, container: '#pie',      type: 'pie',      x: 'status', y: 'charge' });
      createChart({ grid, container: '#donut',    type: 'donut',    x: 'status', y: 'charge' });
      createChart({ grid, container: '#sunburst', type: 'sunburst', x: 'region', y: 'charge' });
      createChart({ grid, container: '#treemap',  type: 'treemap',  x: 'region', y: 'charge' });
    }, []);

    return (
      <>
        <div style={{ display: 'grid', gridTemplateColumns: 'repeat(2, 1fr)', gap: '14px', height: '210px' }}>
          <div id="pie" />
          <div id="donut" />
          <div id="sunburst" />
          <div id="treemap" />
        </div>
        <LatticeGrid
          ref={gridRef}
          rowKey="id"
          columns={columns}
          rows={rows}
          style={{ height: '340px', marginTop: '14px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Lattice Grid Buy a licence

demo D165

Pie, donut, sunburst, treemap

Composition, flat and hierarchical

type: 'pie' · 'donut' · 'sunburst' · 'treemap'

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'status', title: 'Status', filter: { type: 'set' } },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
];

const rows = [/* circuit records */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div style="display:grid;grid-template-columns:repeat(2, 1fr);gap:14px;height:210px">' +
    '<div id="pie"></div>' +
    '<div id="donut"></div>' +
    '<div id="sunburst"></div>' +
    '<div id="treemap"></div>' +
    '</div>' +
    '<lattice-grid [config]="grid" style="display:block;height:340px;margin-top:14px"></lattice-grid>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  grid = {
    rowKey: 'id',
    columns: columns,
    rows: rows,
  };

  ngAfterViewInit() {
    const grid = this.gridRef.grid;
    createChart({ grid, container: '#pie',      type: 'pie',      x: 'status', y: 'charge' });
    createChart({ grid, container: '#donut',    type: 'donut',    x: 'status', y: 'charge' });
    createChart({ grid, container: '#sunburst', type: 'sunburst', x: 'region', y: 'charge' });
    createChart({ grid, container: '#treemap',  type: 'treemap',  x: 'region', y: 'charge' });
  }
}

bootstrapApplication(AppComponent);

Lattice Grid Buy a licence

demo D165

Pie, donut, sunburst, treemap

Composition, flat and hierarchical

type: 'pie' · 'donut' · 'sunburst' · 'treemap'

Building…
Loading a live grid…

The configuration

<script>
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeAction from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/svelte.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';

  const lattice = createLatticeAction({ createGrid });

  let pieEl, donutEl, sunburstEl, treemapEl;

  const config = {
    rowKey: 'id',
    columns: [
      { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'status', title: 'Status', filter: { type: 'set' } },
      { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
      { field: 'charge', title: 'Monthly charge', type: 'number',
        format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
    ],
    rows,  // an array of circuit records
    // onGrid hands over the live grid the moment it is created. The same charge as
    // a composition: pie and donut split it by status, sunburst and treemap by
    // region. Every chart is built from the grid, so all four follow its filters.
    onGrid: (grid) => {
      createChart({ grid, container: pieEl,      type: 'pie',      x: 'status', y: 'charge' });
      createChart({ grid, container: donutEl,    type: 'donut',    x: 'status', y: 'charge' });
      createChart({ grid, container: sunburstEl, type: 'sunburst', x: 'region', y: 'charge' });
      createChart({ grid, container: treemapEl,  type: 'treemap',  x: 'region', y: 'charge' });
    },
  };
</script>

<svelte:head>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">
</svelte:head>

<div style="display: grid; grid-template-columns: repeat(2, 1fr); gap: 14px; grid-auto-rows: 210px">
  <div bind:this={pieEl}></div>
  <div bind:this={donutEl}></div>
  <div bind:this={sunburstEl}></div>
  <div bind:this={treemapEl}></div>
</div>
<div use:lattice={config} style="height: 340px; margin-top: 14px"></div>